import 'package:flutter/material.dart';
import 'package:json_annotation/json_annotation.dart';

part 'settings.g.dart';

@JsonSerializable(explicitToJson: true)
class Settings {
  @JsonKey(
    toJson: _themeToJson,
    fromJson: _themeFromJson,
  )
  ThemeMode appTheme;
  bool devToolsEnabled;

  Settings(this.appTheme, this.devToolsEnabled);

  static String _themeToJson(ThemeMode m) => m.name;
  static ThemeMode _themeFromJson(String m) => ThemeMode.values.firstWhere((element) => element.name == m);

  factory Settings.fromJson(Map<String, dynamic> json) => _$SettingsFromJson(json);
  Map<String, dynamic> toJson() => _$SettingsToJson(this);
}